function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useRef, useState } from 'react';
import { useCombobox } from 'downshift';
import { findIndexOfInputValue } from '../helpers';
export function useAutocomplete(children) {
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    hasError = _useState2[0],
    setHasError = _useState2[1];
  var inputRef = useRef(null);
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    filterValue = _useState4[0],
    setFilterValue = _useState4[1];
  var validChildren = React.Children.toArray(children).filter(React.isValidElement);
  var filteredItems = validChildren.filter(function (child) {
    if (!filterValue) {
      return true;
    }
    return (child.props.children || '').toLowerCase().indexOf(filterValue.toLowerCase()) > -1;
  });
  var itemsMap = Object.fromEntries(validChildren.map(function (child) {
    return [child.props.value, child];
  }));
  function getHasError(inputValue) {
    if (!inputValue) {
      return false;
    }
    return findIndexOfInputValue(filteredItems, inputValue) === -1;
  }
  function onInputValueChange(_ref) {
    var inputValue = _ref.inputValue,
      isOpen = _ref.isOpen,
      type = _ref.type;
    var isControlledValueUpdate = type === useCombobox.stateChangeTypes.ControlledPropUpdatedSelectedItem;
    if (!inputValue || isOpen && !isControlledValueUpdate) {
      setFilterValue(inputValue || '');
    }
    if (!isOpen) {
      setHasError(getHasError(inputValue));
    }
  }
  function onIsOpenChange(_ref2) {
    var inputValue = _ref2.inputValue,
      isOpen = _ref2.isOpen;
    if (isOpen) {
      var _inputRef$current;
      (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.focus();
    } else {
      var _inputRef$current2;
      if (!filterValue && inputRef.current) {
        // Scroll to the beginning of the input in Firefox
        inputRef.current.scrollLeft = 0;
      }
      var newHasError = getHasError(inputValue);
      setHasError(newHasError);
      (_inputRef$current2 = inputRef.current) === null || _inputRef$current2 === void 0 ? void 0 : _inputRef$current2.blur();
    }
  }
  function onSelectedItemChange() {
    setFilterValue('');
  }
  return {
    filteredItems: filteredItems,
    hasFilter: Boolean(filterValue),
    hasError: hasError,
    inputRef: inputRef,
    itemsMap: itemsMap,
    onInputValueChange: onInputValueChange,
    onIsOpenChange: onIsOpenChange,
    onSelectedItemChange: onSelectedItemChange
  };
}